% eda06_09
% time shift using fft example

clear all;

% standard set up
N=256;
Dt=1.0;
tmax=Dt*(N-1); 
t=Dt*[0:N-1]'; 
fmax=1/(2.0*Dt);
df=fmax/(N/2);
f=df*[0:N/2,-N/2+1:-1]'; 
Nf=N/2+1;
dw=2*pi*df;
w=dw*[0:N/2,-N/2+1:-1]';
Nw=Nf;

% exepplary function
w0 = 2*pi*fmax/20;
d = cos(w0*t).*exp(-0.25*w0*t);

% time shift
t0 = t(16);
ds=ifft(exp(-i*w*t0).*fft(d));

figure(1);
clf;
subplot(2,1,1);
set(gca,'LineWidth',2);
hold on;
axis( [0, tmax, -1, 1] );
plot(t,d,'k-','LineWidth',2);
xlabel('time, t');
ylabel('d(t)');
subplot(2,1,2);
set(gca,'LineWidth',2);
hold on;
axis( [0, tmax, -1, 1] );
plot(t,real(ds),'k-','LineWidth',2);
xlabel('time, t');
ylabel('d_shifted(t)');








